package com.muyu.cloud.etl.controller;

import com.muyu.cloud.etl.service.SourceService;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.poi.ExcelUtil;
import com.muyu.common.core.web.controller.BaseController;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.domain.Source;
import com.muyu.domain.req.SourceReq;
import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/source")
public class SourceController extends BaseController {

    @Autowired
    private SourceService sourceService;


    //列表
    @PostMapping("/list")
    public Result<TableDataInfo<Source>> list(@RequestBody SourceReq sourceReq) {
        startPage();
        List<Source> list = sourceService.selectSourceList(sourceReq);
        return getDataTable(list);
    }

    /*
     * 导出
     */
    @PostMapping("/export")
    public void export(HttpServletResponse response, SourceReq sourceReq) {
        response.setCharacterEncoding("UTF-8");
        List<Source> list=   sourceService.selectSourceList(sourceReq);
        ExcelUtil<Source> util = new ExcelUtil<>(Source.class);
        util.exportExcel(response,list,"基础信息");
    }


    /**
     * 获取基础信息详细信息
     */
    @GetMapping(value = "/{id}")
    public Result getInfo(@PathVariable("id") Long id) {
      Source source=  sourceService.getInfo(id);
      return success(source);
    }


    /**
     * 新增基础信息
     */
    @PostMapping("/insert")
    public Result add(@RequestBody Source sourceReq) {

        return toAjax(sourceService.insertBasicConfigInfo(sourceReq));
    }

    //批量删除
    @DeleteMapping("{ids}")
    public Integer delete(@PathVariable("ids") String ids) {
        return sourceService.deleteByIds(ids);
    }

    /**
     * 修改
     */
    @PostMapping("/update")
    public Result update(@RequestBody Source sourceReq) {

        return toAjax(sourceService.updataSource(sourceReq));
    }


    /**
     * 测试连接
     */

    @PostMapping("/connectionTest")
    public Result connectionTest(@RequestBody Source source) throws ServletException {
        return toAjax(sourceService.connectionTest(source));
    }










}
